Index: waflib/Tools/qt4.py
===================================================================
--- waflib/Tools/qt4.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/qt4.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -12,6 +12,6 @@
 	has_xml=True
 import os,sys
-from waflib.Tools import c_preproc,cxx
-from waflib import Task,Utils,Options,Errors
+from waflib.Tools import cxx
+from waflib import Task,Utils,Options,Errors,Context
 from waflib.TaskGen import feature,after_method,extension
 from waflib.Configure import conf
@@ -26,15 +26,4 @@
 		Task.Task.__init__(self,*k,**kw)
 		self.moc_done=0
-	def scan(self):
-		(nodes,names)=c_preproc.scan(self)
-		lst=[]
-		for x in nodes:
-			if x.name.endswith('.moc'):
-				s=x.path_from(self.inputs[0].parent.get_bld())
-				if s not in names:
-					names.append(s)
-			else:
-				lst.append(x)
-		return(lst,names)
 	def runnable_status(self):
 		if self.moc_done:
@@ -57,8 +46,18 @@
 			tsk.set_inputs(h_node)
 			tsk.set_outputs(m_node)
+			if self.generator:
+				self.generator.tasks.append(tsk)
 			gen=self.generator.bld.producer
 			gen.outstanding.insert(0,tsk)
 			gen.total+=1
 			return tsk
+	def moc_h_ext(self):
+		try:
+			ext=Options.options.qt_header_ext.split()
+		except AttributeError:
+			pass
+		if not ext:
+			ext=MOC_H
+		return ext
 	def add_moc_tasks(self):
 		node=self.inputs[0]
@@ -70,25 +69,17 @@
 		else:
 			delattr(self,'cache_sig')
+		include_nodes=[node.parent]+self.generator.includes_nodes
 		moctasks=[]
-		mocfiles=[]
-		try:
-			tmp_lst=bld.raw_deps[self.uid()]
-			bld.raw_deps[self.uid()]=[]
-		except KeyError:
-			tmp_lst=[]
-		for d in tmp_lst:
+		mocfiles=set([])
+		for d in bld.raw_deps.get(self.uid(),[]):
 			if not d.endswith('.moc'):
 				continue
 			if d in mocfiles:
-				Logs.error("paranoia owns")
 				continue
-			mocfiles.append(d)
+			mocfiles.add(d)
 			h_node=None
-			try:ext=Options.options.qt_header_ext.split()
-			except AttributeError:pass
-			if not ext:ext=MOC_H
 			base2=d[:-4]
-			for x in[node.parent]+self.generator.includes_nodes:
-				for e in ext:
+			for x in include_nodes:
+				for e in self.moc_h_ext():
 					h_node=x.find_node(base2+e)
 					if h_node:
@@ -100,26 +91,17 @@
 				for k in EXT_QT4:
 					if base2.endswith(k):
-						for x in[node.parent]+self.generator.includes_nodes:
+						for x in include_nodes:
 							h_node=x.find_node(base2)
 							if h_node:
 								break
-					if h_node:
-						m_node=h_node.change_ext(k+'.moc')
-						break
+						if h_node:
+							m_node=h_node.change_ext(k+'.moc')
+							break
 			if not h_node:
-				raise Errors.WafError('no header found for %r which is a moc file'%d)
-			bld.node_deps[(self.inputs[0].parent.abspath(),m_node.name)]=h_node
+				raise Errors.WafError('No source found for %r which is a moc file'%d)
 			task=self.create_moc_task(h_node,m_node)
 			moctasks.append(task)
-		tmp_lst=bld.raw_deps[self.uid()]=mocfiles
-		lst=bld.node_deps.get(self.uid(),())
-		for d in lst:
-			name=d.name
-			if name.endswith('.moc'):
-				task=self.create_moc_task(bld.node_deps[(self.inputs[0].parent.abspath(),name)],d)
-				moctasks.append(task)
 		self.run_after.update(set(moctasks))
 		self.moc_done=1
-	run=Task.classes['cxx'].__dict__['run']
 class trans_update(Task.Task):
 	run_str='${QT_LUPDATE} ${SRC} -ts ${TGT}'
@@ -141,5 +123,5 @@
 def create_rcc_task(self,node):
 	rcnode=node.change_ext('_rc.cpp')
-	rcctask=self.create_task('rcc',node,rcnode)
+	self.create_task('rcc',node,rcnode)
 	cpptask=self.create_task('cxx',rcnode,rcnode.change_ext('.o'))
 	try:
@@ -180,5 +162,5 @@
 		if len(flag)<2:continue
 		f=flag[0:2]
-		if f in['-D','-I','/D','/I']:
+		if f in('-D','-I','/D','/I'):
 			if(f[0]=='/'):
 				lst.append('-'+flag[1:])
@@ -191,8 +173,9 @@
 class rcc(Task.Task):
 	color='BLUE'
-	run_str='${QT_RCC} -name ${SRC[0].name} ${SRC[0].abspath()} ${RCC_ST} -o ${TGT}'
+	run_str='${QT_RCC} -name ${tsk.rcname()} ${SRC[0].abspath()} ${RCC_ST} -o ${TGT}'
 	ext_out=['.h']
+	def rcname(self):
+		return os.path.splitext(self.inputs[0].name)[0]
 	def scan(self):
-		node=self.inputs[0]
 		if not has_xml:
 			Logs.error('no xml support was found, the rcc dependencies will be incomplete!')
@@ -217,4 +200,8 @@
 	color='BLUE'
 	run_str='${QT_MOC} ${MOC_FLAGS} ${MOCCPPPATH_ST:INCPATHS} ${MOCDEFINES_ST:DEFINES} ${SRC} ${MOC_ST} ${TGT}'
+	def keyword(self):
+		return"Creating"
+	def __str__(self):
+		return self.outputs[0].path_from(self.generator.bld.launch_node())
 class ui4(Task.Task):
 	color='BLUE'
@@ -268,5 +255,5 @@
 	cand=None
 	prev_ver=['4','0','0']
-	for qmk in['qmake-qt4','qmake4','qmake']:
+	for qmk in('qmake-qt4','qmake4','qmake'):
 		try:
 			qmake=self.find_program(qmk,path_list=paths)
@@ -275,5 +262,5 @@
 		else:
 			try:
-				version=self.cmd_and_log([qmake,'-query','QT_VERSION']).strip()
+				version=self.cmd_and_log(qmake+['-query','QT_VERSION']).strip()
 			except self.errors.WafError:
 				pass
@@ -288,5 +275,5 @@
 	else:
 		self.fatal('Could not find qmake for qt4')
-	qtbin=self.cmd_and_log([self.env.QMAKE,'-query','QT_INSTALL_BINS']).strip()+os.sep
+	qtbin=self.cmd_and_log(self.env.QMAKE+['-query','QT_INSTALL_BINS']).strip()+os.sep
 	def find_bin(lst,var):
 		if var in env:
@@ -302,16 +289,15 @@
 	find_bin(['uic-qt3','uic3'],'QT_UIC3')
 	find_bin(['uic-qt4','uic'],'QT_UIC')
-	if not env['QT_UIC']:
+	if not env.QT_UIC:
 		self.fatal('cannot find the uic compiler for qt4')
-	try:
-		uicver=self.cmd_and_log(env['QT_UIC']+" -version 2>&1").strip()
-	except self.errors.ConfigurationError:
-		self.fatal('this uic compiler is for qt3, add uic for qt4 to your path')
+	self.start_msg('Checking for uic version')
+	uicver=self.cmd_and_log(env.QT_UIC+["-version"],output=Context.BOTH)
+	uicver=''.join(uicver).strip()
 	uicver=uicver.replace('Qt User Interface Compiler ','').replace('User Interface Compiler for Qt','')
-	self.msg('Checking for uic version','%s'%uicver)
+	self.end_msg(uicver)
 	if uicver.find(' 3.')!=-1:
 		self.fatal('this uic compiler is for qt3, add uic for qt4 to your path')
 	find_bin(['moc-qt4','moc'],'QT_MOC')
-	find_bin(['rcc'],'QT_RCC')
+	find_bin(['rcc-qt4','rcc'],'QT_RCC')
 	find_bin(['lrelease-qt4','lrelease'],'QT_LRELEASE')
 	find_bin(['lupdate-qt4','lupdate'],'QT_LUPDATE')
@@ -328,10 +314,10 @@
 	if not qtlibs:
 		try:
-			qtlibs=self.cmd_and_log([self.env.QMAKE,'-query','QT_INSTALL_LIBS']).strip()
+			qtlibs=self.cmd_and_log(self.env.QMAKE+['-query','QT_INSTALL_LIBS']).strip()
 		except Errors.WafError:
-			qtdir=self.cmd_and_log([self.env.QMAKE,'-query','QT_INSTALL_PREFIX']).strip()+os.sep
+			qtdir=self.cmd_and_log(self.env.QMAKE+['-query','QT_INSTALL_PREFIX']).strip()+os.sep
 			qtlibs=os.path.join(qtdir,'lib')
 	self.msg('Found the Qt4 libraries in',qtlibs)
-	qtincludes=os.environ.get("QT4_INCLUDES",None)or self.cmd_and_log([self.env.QMAKE,'-query','QT_INSTALL_HEADERS']).strip()
+	qtincludes=os.environ.get("QT4_INCLUDES",None)or self.cmd_and_log(self.env.QMAKE+['-query','QT_INSTALL_HEADERS']).strip()
 	env=self.env
 	if not'PKG_CONFIG_PATH'in os.environ:
Index: waflib/Tools/ruby.py
===================================================================
--- waflib/Tools/ruby.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/ruby.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -28,5 +28,5 @@
 	ruby=self.env.RUBY
 	try:
-		version=self.cmd_and_log([ruby,'-e','puts defined?(VERSION) ? VERSION : RUBY_VERSION']).strip()
+		version=self.cmd_and_log(ruby+['-e','puts defined?(VERSION) ? VERSION : RUBY_VERSION']).strip()
 	except Exception:
 		self.fatal('could not determine ruby version')
@@ -52,7 +52,7 @@
 	version=tuple(map(int,self.env.RUBY_VERSION.split(".")))
 	def read_out(cmd):
-		return Utils.to_list(self.cmd_and_log([self.env.RUBY,'-rrbconfig','-e',cmd]))
+		return Utils.to_list(self.cmd_and_log(self.env.RUBY+['-rrbconfig','-e',cmd]))
 	def read_config(key):
-		return read_out('puts Config::CONFIG[%r]'%key)
+		return read_out('puts RbConfig::CONFIG[%r]'%key)
 	ruby=self.env['RUBY']
 	archdir=read_config('archdir')
@@ -88,5 +88,5 @@
 	self.start_msg('Ruby module %s'%module_name)
 	try:
-		self.cmd_and_log([self.env['RUBY'],'-e','require \'%s\';puts 1'%module_name])
+		self.cmd_and_log(self.env.RUBY+['-e','require \'%s\';puts 1'%module_name])
 	except Exception:
 		self.end_msg(False)
Index: waflib/Tools/tex.py
===================================================================
--- waflib/Tools/tex.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/tex.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -4,5 +4,5 @@
 
 import os,re
-from waflib import Utils,Task,Errors,Logs
+from waflib import Utils,Task,Errors,Logs,Node
 from waflib.TaskGen import feature,before_method
 re_bibunit=re.compile(r'\\(?P<type>putbib)\[(?P<file>[^\[\]]*)\]',re.M)
@@ -15,5 +15,5 @@
 		path=match.group('file')
 		if path:
-			for k in['','.bib']:
+			for k in('','.bib'):
 				Logs.debug('tex: trying %s%s'%(path,k))
 				fi=node.parent.find_resource(path+k)
@@ -24,8 +24,9 @@
 	Logs.debug("tex: found the following bibunit files: %s"%nodes)
 	return nodes
-exts_deps_tex=['','.ltx','.tex','.bib','.pdf','.png','.eps','.ps']
+exts_deps_tex=['','.ltx','.tex','.bib','.pdf','.png','.eps','.ps','.sty']
 exts_tex=['.ltx','.tex']
-re_tex=re.compile(r'\\(?P<type>include|bibliography|putbib|includegraphics|input|import|bringin|lstinputlisting)(\[[^\[\]]*\])?{(?P<file>[^{}]*)}',re.M)
+re_tex=re.compile(r'\\(?P<type>usepackage|RequirePackage|include|bibliography([^\[\]{}]*)|putbib|includegraphics|input|import|bringin|lstinputlisting)(\[[^\[\]]*\])?{(?P<file>[^{}]*)}',re.M)
 g_bibtex_re=re.compile('bibdata',re.M)
+g_glossaries_re=re.compile('\\@newglossary',re.M)
 class tex(Task.Task):
 	bibtex_fun,_=Task.compile_fun('${BIBTEX} ${BIBTEXFLAGS} ${SRCFILE}',shell=False)
@@ -37,6 +38,11 @@
 	Execute the program **makeindex**
 	"""
+	makeglossaries_fun,_=Task.compile_fun('${MAKEGLOSSARIES} ${SRCFILE}',shell=False)
+	makeglossaries_fun.__doc__="""
+	Execute the program **makeglossaries**
+	"""
 	def exec_command(self,cmd,**kw):
 		bld=self.generator.bld
+		Logs.info('runner: %r'%cmd)
 		try:
 			if not kw.get('cwd',None):
@@ -72,4 +78,11 @@
 			global re_tex
 			for match in re_tex.finditer(code):
+				multibib=match.group('type')
+				if multibib and multibib.startswith('bibliography'):
+					multibib=multibib[len('bibliography'):]
+					if multibib.startswith('style'):
+						continue
+				else:
+					multibib=None
 				for path in match.group('file').split(','):
 					if path:
@@ -77,6 +90,9 @@
 						found=None
 						for k in exts_deps_tex:
-							Logs.debug('tex: trying %s%s'%(path,k))
-							found=node.parent.find_resource(path+k)
+							for up in self.texinputs_nodes:
+								Logs.debug('tex: trying %s%s'%(path,k))
+								found=up.find_resource(path+k)
+								if found:
+									break
 							for tsk in self.generator.tasks:
 								if not found or found in tsk.outputs:
@@ -89,4 +105,9 @@
 										parse_node(found)
 										break
+							if found and multibib and found.name.endswith('.bib'):
+								try:
+									self.multibibs.append(found)
+								except AttributeError:
+									self.multibibs=[found]
 						if add_name:
 							names.append(path)
@@ -103,14 +124,20 @@
 			try:
 				ct=aux_node.read()
-			except(OSError,IOError):
+			except EnvironmentError:
 				Logs.error('Error reading %s: %r'%aux_node.abspath())
 				continue
 			if g_bibtex_re.findall(ct):
-				Logs.warn('calling bibtex')
+				Logs.info('calling bibtex')
 				self.env.env={}
 				self.env.env.update(os.environ)
-				self.env.env.update({'BIBINPUTS':self.TEXINPUTS,'BSTINPUTS':self.TEXINPUTS})
+				self.env.env.update({'BIBINPUTS':self.texinputs(),'BSTINPUTS':self.texinputs()})
 				self.env.SRCFILE=aux_node.name[:-4]
 				self.check_status('error when calling bibtex',self.bibtex_fun())
+		for node in getattr(self,'multibibs',[]):
+			self.env.env={}
+			self.env.env.update(os.environ)
+			self.env.env.update({'BIBINPUTS':self.texinputs(),'BSTINPUTS':self.texinputs()})
+			self.env.SRCFILE=node.name[:-4]
+			self.check_status('error when calling bibtex',self.bibtex_fun())
 	def bibunits(self):
 		try:
@@ -120,19 +147,20 @@
 		else:
 			if bibunits:
-				fn=['bu'+str(i)for i in xrange(1,len(bibunits)+1)]
+				fn=['bu'+str(i)for i in range(1,len(bibunits)+1)]
 				if fn:
-					Logs.warn('calling bibtex on bibunits')
+					Logs.info('calling bibtex on bibunits')
 				for f in fn:
-					self.env.env={'BIBINPUTS':self.TEXINPUTS,'BSTINPUTS':self.TEXINPUTS}
+					self.env.env={'BIBINPUTS':self.texinputs(),'BSTINPUTS':self.texinputs()}
 					self.env.SRCFILE=f
 					self.check_status('error when calling bibtex',self.bibtex_fun())
 	def makeindex(self):
+		self.idx_node=self.inputs[0].change_ext('.idx')
 		try:
 			idx_path=self.idx_node.abspath()
 			os.stat(idx_path)
 		except OSError:
-			Logs.warn('index file %s absent, not calling makeindex'%idx_path)
+			Logs.info('index file %s absent, not calling makeindex'%idx_path)
 		else:
-			Logs.warn('calling makeindex')
+			Logs.info('calling makeindex')
 			self.env.SRCFILE=self.idx_node.name
 			self.env.env={}
@@ -142,4 +170,23 @@
 		if os.path.exists(os.path.join(p.abspath(),'btaux.aux')):
 			self.aux_nodes+=p.ant_glob('*[0-9].aux')
+	def makeglossaries(self):
+		src_file=self.inputs[0].abspath()
+		base_file=os.path.basename(src_file)
+		base,_=os.path.splitext(base_file)
+		for aux_node in self.aux_nodes:
+			try:
+				ct=aux_node.read()
+			except EnvironmentError:
+				Logs.error('Error reading %s: %r'%aux_node.abspath())
+				continue
+			if g_glossaries_re.findall(ct):
+				if not self.env.MAKEGLOSSARIES:
+					raise Errors.WafError("The program 'makeglossaries' is missing!")
+				Logs.warn('calling makeglossaries')
+				self.env.SRCFILE=base
+				self.check_status('error when calling makeglossaries %s'%base,self.makeglossaries_fun())
+				return
+	def texinputs(self):
+		return os.pathsep.join([k.abspath()for k in self.texinputs_nodes])+os.pathsep
 	def run(self):
 		env=self.env
@@ -148,39 +195,38 @@
 			env.append_value('PDFLATEXFLAGS','-interaction=batchmode')
 			env.append_value('XELATEXFLAGS','-interaction=batchmode')
-		fun=self.texfun
-		node=self.inputs[0]
-		srcfile=node.abspath()
-		texinputs=self.env.TEXINPUTS or''
-		self.TEXINPUTS=node.parent.get_bld().abspath()+os.pathsep+node.parent.get_src().abspath()+os.pathsep+texinputs+os.pathsep
 		self.cwd=self.inputs[0].parent.get_bld().abspath()
-		Logs.warn('first pass on %s'%self.__class__.__name__)
-		self.env.env={}
-		self.env.env.update(os.environ)
-		self.env.env.update({'TEXINPUTS':self.TEXINPUTS})
-		self.env.SRCFILE=srcfile
-		self.check_status('error when calling latex',fun())
-		self.aux_nodes=self.scan_aux(node.change_ext('.aux'))
-		self.idx_node=node.change_ext('.idx')
+		Logs.info('first pass on %s'%self.__class__.__name__)
+		cur_hash=self.hash_aux_nodes()
+		self.call_latex()
+		self.hash_aux_nodes()
 		self.bibtopic()
 		self.bibfile()
 		self.bibunits()
 		self.makeindex()
-		hash=''
+		self.makeglossaries()
 		for i in range(10):
-			prev_hash=hash
+			prev_hash=cur_hash
+			cur_hash=self.hash_aux_nodes()
+			if not cur_hash:
+				Logs.error('No aux.h to process')
+			if cur_hash and cur_hash==prev_hash:
+				break
+			Logs.info('calling %s'%self.__class__.__name__)
+			self.call_latex()
+	def hash_aux_nodes(self):
+		try:
+			nodes=self.aux_nodes
+		except AttributeError:
 			try:
-				hashes=[Utils.h_file(x.abspath())for x in self.aux_nodes]
-				hash=Utils.h_list(hashes)
-			except(OSError,IOError):
-				Logs.error('could not read aux.h')
-				pass
-			if hash and hash==prev_hash:
-				break
-			Logs.warn('calling %s'%self.__class__.__name__)
-			self.env.env={}
-			self.env.env.update(os.environ)
-			self.env.env.update({'TEXINPUTS':self.TEXINPUTS})
-			self.env.SRCFILE=srcfile
-			self.check_status('error when calling %s'%self.__class__.__name__,fun())
+				self.aux_nodes=self.scan_aux(self.inputs[0].change_ext('.aux'))
+			except IOError:
+				return None
+		return Utils.h_list([Utils.h_file(x.abspath())for x in self.aux_nodes])
+	def call_latex(self):
+		self.env.env={}
+		self.env.env.update(os.environ)
+		self.env.env.update({'TEXINPUTS':self.texinputs()})
+		self.env.SRCFILE=self.inputs[0].abspath()
+		self.check_status('error when calling latex',self.texfun())
 class latex(tex):
 	texfun,vars=Task.compile_fun('${LATEX} ${LATEXFLAGS} ${SRCFILE}',shell=False)
@@ -204,5 +250,5 @@
 @before_method('process_source')
 def apply_tex(self):
-	if not getattr(self,'type',None)in['latex','pdflatex','xelatex']:
+	if not getattr(self,'type',None)in('latex','pdflatex','xelatex'):
 		self.type='pdflatex'
 	tree=self.bld
@@ -212,10 +258,13 @@
 	if getattr(self,'deps',None):
 		deps=self.to_list(self.deps)
-		for filename in deps:
-			n=self.path.find_resource(filename)
-			if not n:
-				self.bld.fatal('Could not find %r for %r'%(filename,self))
-			if not n in deps_lst:
-				deps_lst.append(n)
+		for dep in deps:
+			if isinstance(dep,str):
+				n=self.path.find_resource(dep)
+				if not n:
+					self.bld.fatal('Could not find %r for %r'%(dep,self))
+				if not n in deps_lst:
+					deps_lst.append(n)
+			elif isinstance(dep,Node.Node):
+				deps_lst.append(dep)
 	for node in self.to_nodes(self.source):
 		if self.type=='latex':
@@ -227,21 +276,33 @@
 		task.env=self.env
 		if deps_lst:
-			try:
-				lst=tree.node_deps[task.uid()]
-				for n in deps_lst:
-					if not n in lst:
-						lst.append(n)
-			except KeyError:
-				tree.node_deps[task.uid()]=deps_lst
-		v=dict(os.environ)
-		p=node.parent.abspath()+os.pathsep+self.path.abspath()+os.pathsep+self.path.get_bld().abspath()+os.pathsep+v.get('TEXINPUTS','')+os.pathsep
-		v['TEXINPUTS']=p
+			for n in deps_lst:
+				if not n in task.dep_nodes:
+					task.dep_nodes.append(n)
+		if hasattr(self,'texinputs_nodes'):
+			task.texinputs_nodes=self.texinputs_nodes
+		else:
+			task.texinputs_nodes=[node.parent,node.parent.get_bld(),self.path,self.path.get_bld()]
+			lst=os.environ.get('TEXINPUTS','')
+			if self.env.TEXINPUTS:
+				lst+=os.pathsep+self.env.TEXINPUTS
+			if lst:
+				lst=lst.split(os.pathsep)
+			for x in lst:
+				if x:
+					if os.path.isabs(x):
+						p=self.bld.root.find_node(x)
+						if p:
+							task.texinputs_nodes.append(p)
+						else:
+							Logs.error('Invalid TEXINPUTS folder %s'%x)
+					else:
+						Logs.error('Cannot resolve relative paths in TEXINPUTS %s'%x)
 		if self.type=='latex':
 			if'ps'in outs:
 				tsk=self.create_task('dvips',task.outputs,node.change_ext('.ps'))
-				tsk.env.env=dict(v)
+				tsk.env.env=dict(os.environ)
 			if'pdf'in outs:
 				tsk=self.create_task('dvipdf',task.outputs,node.change_ext('.pdf'))
-				tsk.env.env=dict(v)
+				tsk.env.env=dict(os.environ)
 		elif self.type=='pdflatex':
 			if'ps'in outs:
@@ -250,5 +311,5 @@
 def configure(self):
 	v=self.env
-	for p in'tex latex pdflatex xelatex bibtex dvips dvipdf ps2pdf makeindex pdf2ps'.split():
+	for p in'tex latex pdflatex xelatex bibtex dvips dvipdf ps2pdf makeindex pdf2ps makeglossaries'.split():
 		try:
 			self.find_program(p,var=p.upper())
Index: waflib/Tools/vala.py
===================================================================
--- waflib/Tools/vala.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/vala.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -11,5 +11,5 @@
 	ext_out=['.h']
 	def run(self):
-		cmd=[self.env['VALAC']]+self.env['VALAFLAGS']
+		cmd=self.env.VALAC+self.env.VALAFLAGS
 		cmd.extend([a.abspath()for a in self.inputs])
 		ret=self.exec_command(cmd,cwd=self.outputs[0].parent.abspath())
@@ -160,5 +160,5 @@
 	valac=self.find_program(valac_name,var='VALAC')
 	try:
-		output=self.cmd_and_log(valac+' --version')
+		output=self.cmd_and_log(valac+['--version'])
 	except Exception:
 		valac_version=None
Index: waflib/Tools/xlc.py
===================================================================
--- waflib/Tools/xlc.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/xlc.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -8,8 +8,6 @@
 def find_xlc(conf):
 	cc=conf.find_program(['xlc_r','xlc'],var='CC')
-	cc=conf.cmd_to_list(cc)
 	conf.get_xlc_version(cc)
 	conf.env.CC_NAME='xlc'
-	conf.env.CC=cc
 @conf
 def xlc_common_flags(conf):
Index: waflib/Tools/xlcxx.py
===================================================================
--- waflib/Tools/xlcxx.py	(revision 1a31baf977fc30945946af012270051e3504aa41)
+++ waflib/Tools/xlcxx.py	(revision 904702d027b3e5e51e28a12383eecea0b55611da)
@@ -8,8 +8,6 @@
 def find_xlcxx(conf):
 	cxx=conf.find_program(['xlc++_r','xlc++'],var='CXX')
-	cxx=conf.cmd_to_list(cxx)
 	conf.get_xlc_version(cxx)
 	conf.env.CXX_NAME='xlc++'
-	conf.env.CXX=cxx
 @conf
 def xlcxx_common_flags(conf):
